#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_LargeFishCFG6.h"
std::auto_ptr<Fish_LargeFishCFG6> Fish_LargeFishCFG6::msSingleton(nullptr);

int Fish_LargeFishCFG6::GetCount()
{
	return (int)mMapData.size();
}

const Fish_LargeFishCFG6Data* Fish_LargeFishCFG6::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_LargeFishCFG6Data>& Fish_LargeFishCFG6::GetMapData()
{
	return mMapData;
}

void Fish_LargeFishCFG6::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_LargeFishCFG6.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_LargeFishCFG6Data data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mGeneratorID = element->IntAttribute("GeneratorID");
		data.mFishID = element->IntAttribute("FishID");
		data.mImageInfo = element->Attribute("ImageInfo");
		data.mIsBoss = element->BoolAttribute("IsBoss");
		data.mBackSound = element->Attribute("BackSound");
		data.mDuration = element->IntAttribute("Duration");
		data.mWarnTime = element->IntAttribute("WarnTime");
		data.mFlashTime = element->IntAttribute("FlashTime");
		data.mDieTime = element->IntAttribute("DieTime");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_LargeFishCFG6 Loaded. Load Data:%u", mMapData.size());
}

void Fish_LargeFishCFG6::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_LargeFishCFG6");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_LargeFishCFG6");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_LargeFishCFG6Data data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "GeneratorID", data.mGeneratorID);
		LuaCfgHelper::readInt(L, "FishID", data.mFishID);
		LuaCfgHelper::readString(L, "ImageInfo", data.mImageInfo);
		LuaCfgHelper::readBool(L, "IsBoss", data.mIsBoss);
		LuaCfgHelper::readString(L, "BackSound", data.mBackSound);
		LuaCfgHelper::readInt(L, "Duration", data.mDuration);
		LuaCfgHelper::readInt(L, "WarnTime", data.mWarnTime);
		LuaCfgHelper::readInt(L, "FlashTime", data.mFlashTime);
		LuaCfgHelper::readInt(L, "DieTime", data.mDieTime);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_LargeFishCFG6 Loaded. Load Data:%u", mMapData.size());
}

void Fish_LargeFishCFG6::Reload()
{
	mMapData.clear();
	Load();
}

Fish_LargeFishCFG6* Fish_LargeFishCFG6::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_LargeFishCFG6());
	}
	return msSingleton.get();
}

void Fish_LargeFishCFG6::Release()
{
	msSingleton.reset(nullptr);
}
